diff --git a/configure b/configure
index f1551063d0..7c7b3d73ac 100755
--- a/configure
+++ b/configure
@@ -3695,6 +3695,7 @@ transpose_vaapi_filter_deps="vaapi VAProcPipelineCaps_rotation_flags"
 unsharp_opencl_filter_deps="opencl"
 uspp_filter_deps="gpl avcodec"
 vaguedenoiser_filter_deps="gpl"
+vflip_vulkan_filter_deps="vulkan libglslang"
 vidstabdetect_filter_deps="libvidstab"
 vidstabtransform_filter_deps="libvidstab"
 libvmaf_filter_deps="libvmaf pthreads"
diff --git a/libavfilter/Makefile b/libavfilter/Makefile
index 31d922f75c..5630af3a66 100644
--- a/libavfilter/Makefile
+++ b/libavfilter/Makefile
@@ -493,6 +493,7 @@ OBJS-$(CONFIG_VAGUEDENOISER_FILTER)          += vf_vaguedenoiser.o
 OBJS-$(CONFIG_VARBLUR_FILTER)                += vf_varblur.o framesync.o
 OBJS-$(CONFIG_VECTORSCOPE_FILTER)            += vf_vectorscope.o
 OBJS-$(CONFIG_VFLIP_FILTER)                  += vf_vflip.o
+OBJS-$(CONFIG_VFLIP_VULKAN_FILTER)           += vf_vflip_vulkan.o vulkan.o
 OBJS-$(CONFIG_VFRDET_FILTER)                 += vf_vfrdet.o
 OBJS-$(CONFIG_VIBRANCE_FILTER)               += vf_vibrance.o
 OBJS-$(CONFIG_VIDSTABDETECT_FILTER)          += vidstabutils.o vf_vidstabdetect.o
diff --git a/libavfilter/allfilters.c b/libavfilter/allfilters.c
index 82c50cba49..4bf17ef292 100644
--- a/libavfilter/allfilters.c
+++ b/libavfilter/allfilters.c
@@ -470,6 +470,7 @@ extern const AVFilter ff_vf_vaguedenoiser;
 extern const AVFilter ff_vf_varblur;
 extern const AVFilter ff_vf_vectorscope;
 extern const AVFilter ff_vf_vflip;
+extern const AVFilter ff_vf_vflip_vulkan;
 extern const AVFilter ff_vf_vfrdet;
 extern const AVFilter ff_vf_vibrance;
 extern const AVFilter ff_vf_vidstabdetect;
diff --git a/libavfilter/vf_vflip_vulkan.c b/libavfilter/vf_vflip_vulkan.c
new file mode 100644
index 0000000000..3e9d5b23aa
--- /dev/null
+++ b/libavfilter/vf_vflip_vulkan.c
@@ -0,0 +1,277 @@
+/*
+ * copyright (c) 2021 Wu Jianhua <jianhua.wu@intel.com>
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "libavutil/random_seed.h"
+#include "libavutil/opt.h"
+#include "vulkan.h"
+#include "internal.h"
+
+#define CGS 32
+
+typedef struct VFlipVulkanContext {
+    FFVulkanContext vkctx;
+    FFVkQueueFamilyCtx qf;
+    FFVkExecContext *exec;
+    FFVulkanPipeline *pl;
+
+    VkDescriptorImageInfo input_images[3];
+    VkDescriptorImageInfo output_images[3];
+
+    int initialized;
+} VFlipVulkanContext;
+
+static av_cold int init_filter(AVFilterContext *ctx, AVFrame *in)
+{
+    int err = 0;
+    FFSPIRVShader *shd;
+    VFlipVulkanContext *s = ctx->priv;
+    const int planes = av_pix_fmt_count_planes(s->vkctx.output_format);
+
+    FFVulkanDescriptorSetBinding image_descs[] = {
+        {
+            .name       = "input_image",
+            .type       = VK_DESCRIPTOR_TYPE_COMBINED_IMAGE_SAMPLER,
+            .dimensions = 2,
+            .elems      = planes,
+            .stages     = VK_SHADER_STAGE_COMPUTE_BIT,
+            .updater    = s->input_images,
+        },
+        {
+            .name       = "output_image",
+            .type       = VK_DESCRIPTOR_TYPE_STORAGE_IMAGE,
+            .mem_layout = ff_vk_shader_rep_fmt(s->vkctx.output_format),
+            .mem_quali  = "writeonly",
+            .dimensions = 2,
+            .elems      = planes,
+            .stages     = VK_SHADER_STAGE_COMPUTE_BIT,
+            .updater    = s->output_images,
+        },
+    };
+
+    image_descs[0].sampler = ff_vk_init_sampler(ctx, 1, VK_FILTER_LINEAR);
+    if (!image_descs[0].sampler)
+            return AVERROR_EXTERNAL;
+
+    ff_vk_qf_init(ctx, &s->qf, VK_QUEUE_COMPUTE_BIT, 0);
+
+    {
+        s->pl = ff_vk_create_pipeline(ctx, &s->qf);
+        if (!s->pl)
+            return AVERROR(ENOMEM);
+
+        shd = ff_vk_init_shader(ctx, s->pl, "vflip_compute", image_descs[0].stages);
+        if (!shd)
+            return AVERROR(ENOMEM);
+
+        ff_vk_set_compute_shader_sizes(ctx, shd, (int [3]){ 1, CGS, 1 });
+        RET(ff_vk_add_descriptor_set(ctx, s->pl, shd, image_descs, FF_ARRAY_ELEMS(image_descs), 0));
+
+        GLSLC(0, void main()                                                                   );
+        GLSLC(0, {                                                                             );
+        GLSLC(1,     ivec2 size;                                                               );
+        GLSLC(1,     const ivec2 pos = ivec2(gl_GlobalInvocationID.xy);                        );
+        for (int i = 0; i < planes; i++) {
+            GLSLC(0,                                                                           );
+            GLSLF(1, size = imageSize(output_image[%i]);                                     ,i);
+            GLSLC(1, if (IS_WITHIN(pos, size)) {                                               );
+            GLSLF(2,     vec4 res = texture(input_image[%i], ivec2(pos.x, size.y - pos.y));  ,i);
+            GLSLF(2,     imageStore(output_image[%i], pos, res);                             ,i);
+            GLSLC(1, }                                                                         );
+        }
+        GLSLC(0, }                                                                             );
+
+        RET(ff_vk_compile_shader(ctx, shd, "main"));
+        RET(ff_vk_init_pipeline_layout(ctx, s->pl));
+        RET(ff_vk_init_compute_pipeline(ctx, s->pl));
+    }
+
+    RET(ff_vk_create_exec_ctx(ctx, &s->exec, &s->qf));
+    s->initialized = 1;
+
+fail:
+    return err;
+}
+
+static av_cold void vflip_vulkan_uninit(AVFilterContext *avctx)
+{
+    VFlipVulkanContext *s = avctx->priv;
+    ff_vk_filter_uninit(avctx);
+
+    s->initialized = 0;
+}
+
+static int process_frames(AVFilterContext *avctx, AVFrame *outframe, AVFrame *inframe)
+{
+    int err = 0;
+    VkCommandBuffer cmd_buf;
+    VFlipVulkanContext *s = avctx->priv;
+    FFVulkanFunctions *vk = &s->vkctx.vkfn;
+    AVVkFrame *in = (AVVkFrame *)inframe->data[0];
+    AVVkFrame *out = (AVVkFrame *)outframe->data[0];
+    const int planes = av_pix_fmt_count_planes(s->vkctx.output_format);
+    const VkFormat *input_formats = av_vkfmt_from_pixfmt(s->vkctx.input_format);
+    const VkFormat *output_formats = av_vkfmt_from_pixfmt(s->vkctx.output_format);
+
+    ff_vk_start_exec_recording(avctx, s->exec);
+    cmd_buf = ff_vk_get_exec_buf(avctx, s->exec);
+
+    for (int i = 0; i < planes; i++) {
+        RET(ff_vk_create_imageview(avctx, s->exec, &s->input_images[i].imageView,
+                                   in->img[i],
+                                   input_formats[i],
+                                   ff_comp_identity_map));
+
+        RET(ff_vk_create_imageview(avctx, s->exec, &s->output_images[i].imageView,
+                                   out->img[i],
+                                   output_formats[i],
+                                   ff_comp_identity_map));
+
+        s->input_images[i].imageLayout  = VK_IMAGE_LAYOUT_SHADER_READ_ONLY_OPTIMAL;
+        s->output_images[i].imageLayout = VK_IMAGE_LAYOUT_GENERAL;
+    }
+
+    ff_vk_update_descriptor_set(avctx, s->pl, 0);
+
+    for (int i = 0; i < planes; i++) {
+        VkImageMemoryBarrier barriers[] = {
+            {
+                .sType                       = VK_STRUCTURE_TYPE_IMAGE_MEMORY_BARRIER,
+                .srcAccessMask               = 0,
+                .dstAccessMask               = VK_ACCESS_SHADER_READ_BIT,
+                .oldLayout                   = in->layout[i],
+                .newLayout                   = s->input_images[i].imageLayout,
+                .srcQueueFamilyIndex         = VK_QUEUE_FAMILY_IGNORED,
+                .dstQueueFamilyIndex         = VK_QUEUE_FAMILY_IGNORED,
+                .image                       = in->img[i],
+                .subresourceRange.aspectMask = VK_IMAGE_ASPECT_COLOR_BIT,
+                .subresourceRange.levelCount = 1,
+                .subresourceRange.layerCount = 1,
+            },
+            {
+                .sType                       = VK_STRUCTURE_TYPE_IMAGE_MEMORY_BARRIER,
+                .srcAccessMask               = 0,
+                .dstAccessMask               = VK_ACCESS_SHADER_WRITE_BIT,
+                .oldLayout                   = out->layout[i],
+                .newLayout                   = s->output_images[i].imageLayout,
+                .srcQueueFamilyIndex         = VK_QUEUE_FAMILY_IGNORED,
+                .dstQueueFamilyIndex         = VK_QUEUE_FAMILY_IGNORED,
+                .image                       = out->img[i],
+                .subresourceRange.aspectMask = VK_IMAGE_ASPECT_COLOR_BIT,
+                .subresourceRange.levelCount = 1,
+                .subresourceRange.layerCount = 1,
+            },
+        };
+
+        vk->CmdPipelineBarrier(cmd_buf, VK_PIPELINE_STAGE_TOP_OF_PIPE_BIT,
+                               VK_PIPELINE_STAGE_COMPUTE_SHADER_BIT, 0,
+                               0, NULL, 0, NULL, FF_ARRAY_ELEMS(barriers), barriers);
+
+        in->layout[i]  = barriers[0].newLayout;
+        in->access[i]  = barriers[0].dstAccessMask;
+
+        out->layout[i] = barriers[1].newLayout;
+        out->access[i] = barriers[1].dstAccessMask;
+    }
+
+    ff_vk_bind_pipeline_exec(avctx, s->exec, s->pl);
+
+    vk->CmdDispatch(cmd_buf, s->vkctx.output_width,
+                    FFALIGN(s->vkctx.output_height, CGS)/CGS, 1);
+
+    ff_vk_add_exec_dep(avctx, s->exec, inframe, VK_PIPELINE_STAGE_TOP_OF_PIPE_BIT);
+    ff_vk_add_exec_dep(avctx, s->exec, outframe, VK_PIPELINE_STAGE_TOP_OF_PIPE_BIT);
+
+    err = ff_vk_submit_exec_queue(avctx, s->exec);
+    if (err)
+        return err;
+
+    ff_vk_qf_rotate(&s->qf);
+
+    return 0;
+fail:
+    ff_vk_discard_exec_deps(avctx, s->exec);
+    return err;
+}
+
+static int vflip_vulkan_filter_frame(AVFilterLink *link, AVFrame *in)
+{
+    int err;
+    AVFrame *out = NULL;
+    AVFilterContext *ctx = link->dst;
+    VFlipVulkanContext *s = ctx->priv;
+    AVFilterLink *outlink = ctx->outputs[0];
+
+    out = ff_get_video_buffer(outlink, outlink->w, outlink->h);
+    if (!out) {
+        err = AVERROR(ENOMEM);
+        goto fail;
+    }
+
+    if (!s->initialized)
+        RET(init_filter(ctx, in));
+
+    RET(process_frames(ctx, out, in));
+
+    RET(av_frame_copy_props(out, in));
+
+    av_frame_free(&in);
+
+    return ff_filter_frame(outlink, out);
+
+fail:
+    av_frame_free(&in);
+    av_frame_free(&out);
+    return err;
+}
+
+static const AVOption vflip_vulkan_options[] = {
+    { NULL },
+};
+
+AVFILTER_DEFINE_CLASS(vflip_vulkan);
+
+static const AVFilterPad vflip_vulkan_inputs[] = {
+    {
+        .name         = "default",
+        .type         = AVMEDIA_TYPE_VIDEO,
+        .filter_frame = &vflip_vulkan_filter_frame,
+        .config_props = &ff_vk_filter_config_input,
+    }
+};
+
+static const AVFilterPad vflip_vulkan_outputs[] = {
+    {
+        .name         = "default",
+        .type         = AVMEDIA_TYPE_VIDEO,
+        .config_props = &ff_vk_filter_config_output,
+    }
+};
+
+const AVFilter ff_vf_vflip_vulkan = {
+    .name           = "vflip_vulkan",
+    .description    = NULL_IF_CONFIG_SMALL("Vertically flip the input video in Vulkan"),
+    .priv_size      = sizeof(VFlipVulkanContext),
+    .init           = &ff_vk_filter_init,
+    .uninit         = &vflip_vulkan_uninit,
+    FILTER_INPUTS(vflip_vulkan_inputs),
+    FILTER_OUTPUTS(vflip_vulkan_outputs),
+    FILTER_SINGLE_PIXFMT(AV_PIX_FMT_VULKAN),
+    .priv_class     = &vflip_vulkan_class,
+    .flags_internal = FF_FILTER_FLAG_HWFRAME_AWARE,
+};